# stuff to be implemented externally:
Source10: kmodtool
%define   kmodtool bash %{SOURCE10}
# end stuff to be ...

# hardcode for now:
%{!?kversion: %define kversion 2.6.17-1.2139_FC5}

%define kmod_name ntfs
%define kverrel %(%{kmodtool} verrel %{?kversion} 2>/dev/null)

%define upvar ""
%ifarch i686 ppc
%define smpvar smp
%endif
%ifarch i686 x86_64
%define xenvar xen0 xenU
%define kdumpvar kdump
%endif
%{!?kvariants: %define kvariants %{?upvar} %{?smpvar} %{?xenvar} %{?kdumpvar}}

Name:           %{kmod_name}-kmod
Version:        2.1.27
Release:        1.%(echo %{kverrel} | tr - _)
Summary:        NTFS Kernel Module

Group:          System Environment/Kernel
License:        GPL
URL:            http://www.linux-ntfs.org/
# Created after extracing linux-2.6.16.tar.bz2 and running:
# tar -cvjf ~/rpmbuild/SOURCES/ntfs-2.1.27.tar.bz2 Documentation/filesystems/ntfs.txt COPYING fs/ntfs/
Source0:	ntfs-2.1.27.tar.bz2
Patch0:		CONFIG_NTFS_FS.patch
Patch1:		CONFIG_NTFS_RW.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
ExclusiveArch:	i586 i686 x86_64 ppc

%description
This RPM contains a binary Linux kernel module build for %{kernel}. It 
provides safe read-only NTFS support. 

# magic hidden here:
%{expand:%(%{kmodtool} rpmtemplate %{kmod_name} %{kverrel} %{kvariants} 2>/dev/null)}


%prep
# to understand the magic better or to debug it, uncomment this:
#{kmodtool} rpmtemplate %{kmod_name} %{kverrel} %{kvariants} 2>/dev/null
#sleep 5
%setup -q -c -T -a 0
pushd ./fs/ntfs/
%patch0 -b .patch0
%patch1 -b .patch1
popd
for kvariant in %{kvariants} ; do
    cp -a fs _kmod_build_$kvariant
done


%build
for kvariant in %{kvariants}
do
    ksrc=%{_usrsrc}/kernels/%{kverrel}${kvariant:+-$kvariant}-%{_target_cpu}
    cd _kmod_build_$kvariant
    make -C "${ksrc}" SUBDIRS=$PWD/ntfs modules
    cd ..
done


%install
rm -rf $RPM_BUILD_ROOT
for kvariant in %{kvariants}
do
    install -D -m 755 _kmod_build_${kvariant}/ntfs/ntfs.ko $RPM_BUILD_ROOT/lib/modules/%{kverrel}${kvariant}/extra/%{kmod_name}/ntfs.ko
done


%clean
rm -rf $RPM_BUILD_ROOT


%changelog
* Sat Jun 24 2006 Thorsten Leemhuis <fedora[AT]leemhuis[DOT]info> - 2.1.27-1
- update to version from 2.6.17

* Sun Jun 11 2006 Ville Skyttä <ville.skytta at iki.fi> - 2.1.26-7
- Invoke kmodtool with bash instead of sh.

* Sun May 14 2006 Ville Skyttä <ville.skytta at iki.fi> - 2.1.26-6
- Require version >= of ntfs-kmod-common.
- Provide ntfs-kmod instead of kmod-ntfs to fix upgrade woes (#970).

* Thu Apr 27 2006 Ville Skyttä <ville.skytta at iki.fi> - 2.1.26-5
- Provide "kernel-modules" instead of "kernel-module" to match yum's config.

* Tue Mar 28 2006 Thorsten Leemhuis <fedora[AT]leemhuis[DOT]info> - 2.1.26-4
- small adjustments to kmod specific tasks
- update kmodtool to 0.10.6

* Fri Mar 17 2006 Thorsten Leemhuis <fedora[AT]leemhuis[DOT]info> - 2.1.26-2
- build for kdump
- no ppc64 for now
- drop 0.lvn

* Wed Mar 08 2006 Thorsten Leemhuis <fedora[AT]leemhuis[DOT]info> - 0:2.1.26-0.lvn.2
- ppc mirror out of sync -- disable ppc for now

* Wed Mar 08 2006 Thorsten Leemhuis <fedora[AT]leemhuis[DOT]info> - 0:2.1.26-0.lvn.1
- forgot to hardcode kversion
- update to version from 2.6.16

* Wed Mar 08 2006 Thorsten Leemhuis <fedora[AT]leemhuis[DOT]info> - 0:2.1.25-0.lvn.2
- add ppc and ppc64
- hardcode variants for now

* Wed Feb 08 2006 Thorsten Leemhuis <fedora[AT]leemhuis[DOT]info> - 0:2.1.25-0.lvn.1
- Rename to ntfs-kmod
- Remove the common parts

* Sun Jan 08 2006 Thorsten Leemhuis <fedora[AT]leemhuis[DOT]info> - 0:2.1.25-0.lvn.1
- Update to 2.1.25
- Enable rw by default

* Sat Jun 04 2005 Thorsten Leemhuis <fedora[AT]leemhuis[DOT]info> - 0:2.1.22-0.lvn.3
- Adjust to new kmodules scheme -- should work better with FC4

* Sat Jun 04 2005 Thorsten Leemhuis <fedora[AT]leemhuis[DOT]info> - 0:2.1.22-0.lvn.2
- Update to Version from 2.6.12 tree
- Adjust BR for FC4
- Include Changelog in %%doc

* Tue Jan 05 2005 Thorsten Leemhuis <fedora[AT]leemhuis[DOT]info> - 0:2.1.22-0.lvn.1
- Update to 2.1.22

* Fri Nov 05 2004 Thorsten Leemhuis <fedora[AT]leemhuis[DOT]info> - 0:2.1.20-0.lvn.1
- Update to 2.1.20
- Build without kernel-module-devel as default
- BR post, postun /sbin/depmod 

* Sat Oct 16 2004 Thorsten Leemhuis <fedora[AT]leemhuis[DOT]info> - 0:2.1.15-0.lvn.9
- Make Build independant of kernel-sourcecode / include sources directly
- Allow building without kernel-module-devel
- Change rhkernel usage again. Use it not for the BR. BR kernel and Co
  always if no srcdir with ksrc provided.
- Allow rpm to strip the kernel module.

* Fri Sep 24 2004 Thorsten Leemhuis <fedora[AT]leemhuis[DOT]info> - 0:2.1.15-0.lvn.8
- Can's use fedora-kmodhelper to detect kverrel when it is not installed 
  -> moved kverrel detection to a hardcoded sed command

* Wed Sep 15 2004 Thorsten Leemhuis <fedora[AT]leemhuis[DOT]info> - 0:2.1.15-0.lvn.7
- Removed rhkernel detection completely

* Wed Sep 15 2004 Thorsten Leemhuis <fedora[AT]leemhuis[DOT]info> - 0:2.1.15-0.lvn.6
- BuildRequire fedora-rpmdevtools

* Wed Sep 15 2004 Thorsten Leemhuis <fedora[AT]leemhuis[DOT]info> - 0:2.1.15-0.lvn.5
- rhkernel default
- make srpm uniqe (don't depend on kernel-version)
- remove fedora-kmodhelper
- use kernel-module-devel

* Mon Sep 13 2004 Thorsten Leemhuis <fedora[AT]leemhuis[DOT]info> - 0:2.1.15-0.lvn.4
- Fail correctly if kernel is not installed when building for a fedora-kernel
- Re-Do rhkernel-detection workaround

* Sun Sep 12 2004 Thorsten Leemhuis <fedora[AT]leemhuis[DOT]info> - 0:2.1.15-0.lvn.3
- Do not fail and warn if a ksrc is not found
- disable rhkernel-detection for the moment  

* Fri Sep 03 2004 Thorsten Leemhuis <fedora[AT]leemhuis[DOT]info> - 0:2.1.15-0.lvn.2
- Simple build fix to allow use of kernel-module-devel package

* Sun Aug 29 2004 Thorsten Leemhuis <fedora[AT]leemhuis[DOT]info> - 0:2.1.15-0.lvn.1
- Use rhkernel macro so building for custom kernels works
- Buildrequier kernel-sourcecode, kernel-source does not work

* Wed Aug 11 2004 Thorsten Leemhuis <fedora[AT]leemhuis[DOT]info> - 0:2.1.14-0.lvn.2
- Use another build approach as suggested by arjanv in 
  129377#c3@bugzilla.redhat.com

* Sun Aug 01 2004 Thorsten Leemhuis <fedora[AT]leemhuis[DOT]info> - 0:2.1.14-0.lvn.1
- Initial RPM release.
